//css_ref System.Data;
//css_ref System.Transactions;
//css_ref System.Xml;
//css_ref Interop.SAPbobsCOM.dll;
//css_ref log4net.dll;
//css_ref Produmex.Foundation.dll;
//using Produmex.Foundation.Data.dll;
//css_ref Produmex.Foundation.Data.Sbo.dll;
//using Produmex.Foundation.Sbo.dll;
//css_ref Produmex.Sbo.Logex.Data.dll;
//css_ref Produmex.Sbo.Logex.Fairfield.dll;

using System;
using System.Diagnostics;
using System.Reflection;
using System.Transactions;
using Produmex.Foundation.Data.Sbo;
using Produmex.Foundation.Data.Sbo.Attributes;
using Produmex.Foundation.Data.Sbo.BusinessObjects;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Convertors;
using Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.Sbo.Providers;
using Produmex.Foundation.Data.Sbo.Utilities;
using Produmex.Foundation.Diagnostics;
using Produmex.Foundation.Reflection;
using Produmex.Foundation.Resources;
using Produmex.Sbo.Logex.Data.BusinessObjects;
using Produmex.Sbo.Logex.Fairfield.Generators.PickListRobot;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions;
using Produmex.Sbo.Logex.Data.Providers;
using Produmex.Sbo.Logex.Data;
using Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.Tables;
using Produmex.Foundation.Data.DbClient;
using Produmex.Foundation.Data;
using Produmex.Foundation;
using Produmex.Sbo.Logex.Data.Generators.PickListController;
using Produmex.Sbo.Logex.Fairfield.Generators.PickListController;

namespace AddUpdateScript
{
	class Program
	{
		static string CONNECTION_STRING = "Server=DEV_SAP9_FR;CompanyDB=SBODemo_US_64;ExtraDb=PMX_SBODemo_US_64;UseTrusted=False;DbUserName=sa;DbPassword=B1Admin;UserName=manager;Password=produmex;Pooling=True;MinPoolSize=2;MaxPoolSize=10;ServerType=MSSQL2008;DBCultureInfo=en-US;LicenseServer=localhost:30000";

		/// <summary>
		/// Used for logging
		/// </summary>
		private static readonly ILog s_log = LogProvider.GetLogger(MethodInfo.GetCurrentMethod().DeclaringType);

		static void Main(string[] args)
		{
			try
			{
				Produmex.Foundation.Diagnostics.LogProvider.SetConsoleAppender("WARN");
				Execute();
			}
			catch (Exception ex)
			{
				s_log.Error("", ex);
			}
			if (Debugger.IsAttached)
			{
				Console.WriteLine("Press <Enter>");
				Console.ReadLine();
			}
		}

		static void Execute()
		{

			using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
			{
				using (SboConnection conn = new SboConnection(CONNECTION_STRING))
				{
					conn.Open(); //Open connection to SAP
					Console.WriteLine("Connection is open to database");

					PmxDbVersionUpdaterProvider updateProv = new PmxDbVersionUpdaterProvider(conn);

					updateProv.AddUpdateExtension(PickListRobot.IDs.ExtCode, "Fairfield Pick List robot",
						typeof(Produmex.Sbo.Logex.Fairfield.Generators.PickListRobot.PickListRobot), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IPICKLISTROBOT);


					Console.WriteLine("Views");
					// Views
					Assembly assembly = Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.Fairfield.SboCommands));
					string viewName = Produmex.Sbo.Logex.Fairfield.ViewObjects.Definitions.Views.PmxEmptyDynamicPickLocationsViewDefinitionFF.NAME;
					string resourceName = "Produmex.Sbo.Logex.Fairfield" + ".Scripts.Views." + viewName + ".sql";
					conn.DbTool.CreateUpdateView(viewName, updateProv.PreprocessSqlScript(ResourceHelper.ReadResourceContentAsString(assembly, resourceName)));


					viewName = Produmex.Sbo.Logex.Fairfield.ViewObjects.Definitions.Views.PmxStockNeededForDynamicReplenishmentViewDefinitionFF.NAME;
					resourceName = "Produmex.Sbo.Logex.Fairfield" + ".Scripts.Views." + viewName + ".sql";
					conn.DbTool.CreateUpdateView(viewName, updateProv.PreprocessSqlScript(ResourceHelper.ReadResourceContentAsString(assembly, resourceName)));


					viewName = Produmex.Sbo.Logex.Fairfield.ViewObjects.Definitions.Views.PmxRemoveFromDynamicLocViewDefinitionFF.NAME;
					resourceName = "Produmex.Sbo.Logex.Fairfield" + ".Scripts.Views." + viewName + ".sql";
					conn.DbTool.CreateUpdateView(viewName, updateProv.PreprocessSqlScript(ResourceHelper.ReadResourceContentAsString(assembly, resourceName)));


					AddPickListController(updateProv);

				}

				//Complete transaction
				scope.Complete();
			}

			////PMX connection
			//using (TransactionScope scope = PmxDbConnection.GetNewTransactionScope())
			//{
			//	using (PmxDbConnectionSql dbConn = new PmxDbConnectionSql(CONNECTION_STRING))
			//	{
			//		dbConn.Open();

					


			//		//Complete transaction
			//		scope.Complete();
			//	}
			//}

			Console.WriteLine("Done ...");
		}




		private static void AddPickListController(PmxDbVersionUpdaterProvider updateProv)
		{
			const int Sequence1 = 1;

			updateProv.AddUpdateExtension(PickListControllerFF.IDs.ExtCode, "Pick list controller - Fairfield", typeof(PickListControllerFF), Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxExtensionTypeCodes.IPICKLISTCONTROLLER);

			updateProv.AddUpdateExtensionParameter(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_CAN_PICK_FULL_LUID_FROM_BULK_LOCATION,
				"Can the user pick full pallet from bulk location? (Y/N)",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.True, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_MUST_FIRST_PICK_FULL_LUID_FROM_BULK_LOCATION,
				"Must the user first pick full pallet from bulk location? (Y/N)",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.True, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_FORCE_PICK_FULL_LUID,
				"Force the user to pick full pallet? (Y/N)",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.True, PickListController.Grouping.General);
			updateProv.AddUpdateExtensionParameter(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ONLY_ITEMS_UNDER_DOCK,
				"Only pick items on location on same or lower level as dock? (Y/N)",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False, PickListController.Grouping.General);
			updateProv.AddUpdateExtensionParameter(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_COPY_BATCH_FOR_ALTERNATE_ITEMS,
				"Copy batch number when selecting alternate item? (Y/N)",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_MAKE_READY_BEFORE_PRINT,
				"Make picklist ready before print? (Y/N)",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.True,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_MAKE_READY_BEFORE_PRINT, PickListController.Grouping.General);
			updateProv.AddUpdateExtensionParameter(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_CUSTOM_WAVE_DESCR_JOIN_SQL,
				"JOIN-sql for custom wave description for scanner",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR, null, PmxExtensionParameterCodes.PICKLIST_CONTROLLER_CUSTOM_WAVE_DESCR_JOIN_SQL, 900, PickListController.Grouping.General);
			updateProv.AddUpdateExtensionParameter(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_CUSTOM_WAVE_DESCR_FIELDS,
				"Custom wave description fields for scanner",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR, null, PmxExtensionParameterCodes.PICKLIST_CONTROLLER_CUSTOM_WAVE_DESCR_FIELDS, 901, PickListController.Grouping.General);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamCopyNonInventoryItemsToResInv,
				"Copy non-inventory items to reserve invoice?",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_COPY_NON_INVENTORY_ITEMS_TO_RES_INV, PickListController.Grouping.General);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamPickItemsOrderBy,
				"Pick items order by", PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_VALID_VALUE_LIST_CONVERTOR,
				PmxPickListItemOrderByCodes.FULL_LOCATION_NO_PICK, PmxExtensionParameterCodes.PICKLIST_CONTROLLER_PICK_ITEMS_ORDER_BY, 900, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateParameterValidValue(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_PICK_ITEMS_ORDER_BY, PmxPickListItemOrderByCodes.FULL_LOCATION_NO_PICK, "Order by Full LUID, sequence, no location");
			updateProv.AddUpdateParameterValidValue(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_PICK_ITEMS_ORDER_BY, PmxPickListItemOrderByCodes.FULL_PICKEDITEM_LOCATION, "Order by Full LUID, picked item, locationcode");
			updateProv.AddUpdateParameterValidValue(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_PICK_ITEMS_ORDER_BY, PmxPickListItemOrderByCodes.SEQUENCE_LOCATION_FULLLUID, "Order by Sequence, location code, full LUID");
			updateProv.AddUpdateParameterValidValue(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_PICK_ITEMS_ORDER_BY, PmxPickListItemOrderByCodes.CUSTOM_STORED_PROCEDURE, "Order by Custom stored procedure");

			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamPickItemsOrderByCustomSP,
				"Pick items order by - Stored procedure name",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_CONVERTOR, "PMX_SP_PickItemsOrderByLineNum",
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_PICK_ITEMS_ORDER_BY_CUSTOM_SP, 901, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAdHocAlternateItem,
				"Ad hoc alternate item? (Y/N)",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_AD_HOC_ALTERNATE_ITEM, (int)PickListControllerFF.IDs.ExtensionParameterType.Default, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAllowAllGoodsPickedConfirm,
				"Allow confirmation that ALL goods were picked",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.True,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ALLOW_ALL_GOODS_PICKED_CONFIRM, (int)PickListControllerFF.IDs.ExtensionParameterType.AdHoc, PickListController.Grouping.AdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAutoMoveSSCCOnCustomerCollect,
				"Auto move SSCC on a customer-collected related move",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_AUTO_MOVE_SSCC_ON_CUSTOMER_COLLECT, Sequence1, PickListController.Grouping.AdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamEnterReasonWhenSkippingFirstLocationAdHocPicking,
				"Reason requirements when skipping first location (Ad hoc picking)",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_VALID_VALUE_LIST_CONVERTOR,
				PmxPickListRequiresReasonCodes.REQUIRES_NO_REASON, PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ENTER_REASON_SKIP_FIRST_LOC_ADHOC_PICKING,
				(int)PickListControllerFF.IDs.ExtensionParameterType.AdHoc, PickListController.Grouping.AdHocPicking);
			updateProv.AddUpdateParameterValidValue(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ENTER_REASON_SKIP_FIRST_LOC_ADHOC_PICKING, PmxPickListRequiresReasonCodes.REQUIRES_NO_REASON, "No reason is necessary.");
			updateProv.AddUpdateParameterValidValue(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ENTER_REASON_SKIP_FIRST_LOC_ADHOC_PICKING, PmxPickListRequiresReasonCodes.REQUIRES_REASON_FREE_TEXT, "Requires user-entered reasontext");
			updateProv.AddUpdateParameterValidValue(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ENTER_REASON_SKIP_FIRST_LOC_ADHOC_PICKING, PmxPickListRequiresReasonCodes.REQUIRES_SELECTED_REASON, "Requires selected reason from list");
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAdHocPickOnlyWithSSCC,
				"Ad hoc: Force to scan SSCC? (Y/N)", PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_AD_HOC_PICKING_ONLY_WITH_SSCC, (int)PickListControllerFF.IDs.ExtensionParameterType.AdHoc, PickListController.Grouping.AdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAllowToCreateMasterSSCC,
				"Allow to create master SSCC? (Y/N)",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ALLOW_TO_CREATE_MASTER_SSCC, PickListController.Grouping.General);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAllowMultipleCustomersOnSSCC,
				"Allow multiple customers on SSCC?",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ALLOW_MULTIPLE_CUSTOMERS_ON_SSCC, PickListController.Grouping.General);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAutoFillInQuantityForPackingTypes,
				"Auto fill quantity for packaging types?", PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_AUTO_FILL_QTY_PACK_TYPES, PickListController.Grouping.General);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamWaveOrderBy, "Wave order by",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_VALID_VALUE_LIST_CONVERTOR,
				PmxWaveOrderByCodes.PRIORITY_DUE_KEY, PmxExtensionParameterCodes.PICKLIST_CONTROLLER_WAVE_ORDER_BY, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateParameterValidValue(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_WAVE_ORDER_BY, PmxWaveOrderByCodes.PRIORITY_DUE_KEY, "Order by priority, due date, wave key");
			updateProv.AddUpdateParameterValidValue(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_WAVE_ORDER_BY, PmxWaveOrderByCodes.DUE_PRIORITY_KEY, "Order by due date, priority, wave key");
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAutoSelectWave, "Auto select the wave?",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_AUTO_SELECT_WAVE, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAutoSelectItri, "Auto select batch/BBD on picking?",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_AUTO_SELECT_ITRI, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAllowToIdentifySSCCToPickOn, "Allow to identify the SSCC to pick on?",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ALLOW_TO_IDENTIFY_SSCC_TO_PICK_ON, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAllowToSelectItemToPick,
				"Allow to select the item to pick?", PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ALLOW_TO_SELECT_ITEM_TO_PICK, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamConsolidateItemsToPick, "Consolidate items to pick?",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_CONSOLIDATE_ITEMS_TO_PICK, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamDisableSelectionOfItems,
				"Disable selection of items? (Y/N)",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_DISABLE_SELECTION_OF_ITEMS, PickListController.Grouping.General);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamRoutePickingPickListOrderBy,
				"Route picking picklist order by", PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_VALID_VALUE_LIST_CONVERTOR,
				PmxRoutePickingPickListOrderByCodes.PRIORITY_DUEDATE_DOCENTRY, PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ROUTEPICKING_PICKLIST_ORDER_BY, PickListController.Grouping.AdHocPicking);
			updateProv.AddUpdateParameterValidValues(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ROUTEPICKING_PICKLIST_ORDER_BY, typeof(PmxRoutePickingPickListOrderByCodes));
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAllowCycleCountOfOriginalPickLocationOnAlternatePicking,
				"Allow cycle count on alternate picking? (Y/N)",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ALLOW_CYCLE_COUNT_OF_ORIGINAL_PICK_LOCATION_ON_ALTERNATE_PICKING, (int)PickListControllerFF.IDs.ExtensionParameterType.Default, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamLockWaveByZoneUserForZonePicking,
				"Lock wave by zone/user (Zone picking)",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_LOCK_WAVE_BY_ZONE_USER_FOR_ZONE_PICKING, (int)PickListControllerFF.IDs.ExtensionParameterType.ZonePicking, PickListController.Grouping.ZonePicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamOnlyShowCompletelyUnlockedWavesOnZonePicking,
				"Only show completely unlocked waves in case of zone picking?",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ONLY_SHOW_COMPLETELY_UNLOCKED_WAVES_FOR_ZONE_PICKING, (int)PickListControllerFF.IDs.ExtensionParameterType.ZonePicking, PickListController.Grouping.ZonePicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamMsgItemIsPickedTimeInterval,
				"Time to show 'item is picked' message?",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_INT32_CONVERTOR,
				"0", PmxExtensionParameterCodes.PICKLIST_CONTROLLER_MSG_ITEM_IS_PICKED_TIME_INTERVAL, (int)PickListControllerFF.IDs.ExtensionParameterType.Default, PickListController.Grouping.General);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamPackingMsgPickPackRemarksTimeInterval,
				"Time to show pick/pack remarks on packing?",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_INT32_CONVERTOR, "-1",
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_PACKING_MSG_PICK_PACK_REMARKS_TIME_INTERVAL, (int)PickListControllerFF.IDs.ExtensionParameterType.Packing, PickListController.Grouping.Packing);
			updateProv.AddUpdateExtensionParameter(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_CAN_PICK_BULK_QTY_FROM_BULK_LOCATION,
				"Can the user pick bulk quantity from bulk location? (Y/N)",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR,
				ProdumexValues.False, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamPickFromBulkForAdhocPicking,
				"Allow ad hoc picking from bulk locations?",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_ALLOW_ADHOC_PICKING_FROM_BULK, (int)PickListControllerFF.IDs.ExtensionParameterType.AdHoc, PickListController.Grouping.AdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamChooseDockAdhocPicking,
				"Choose dock on ad hoc picking?",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_CHOOSE_DOCK_ADHOC_PICKING, (int)PickListControllerFF.IDs.ExtensionParameterType.AdHoc, PickListController.Grouping.AdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamKeepPickingSameItemForAdhocPicking,
				"Ad hoc picking: Keep picking same item? (Y/N)",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_KEEP_PICKING_SAME_ITEM_ADHOC_PICKING, (int)PickListControllerFF.IDs.ExtensionParameterType.AdHoc, PickListController.Grouping.AdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamKeepPickingSameLocationForPicking,
				"Picking: Keep picking same location? (Y/N)",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_KEEP_PICKING_SAME_LOCATION_PICKING, (int)PickListControllerFF.IDs.ExtensionParameterType.Default, PickListController.Grouping.Picking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAutoFillInitialQuantityAdHocPicking,
				"Ad hoc: Auto fill pick quantity? (Y/N)", PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR,
				ProdumexValues.False, PmxExtensionParameterCodes.PICKLIST_CONTROLLER_AD_HOC_AUTO_FILL_INITIAL_QUANTITY, (int)PickListControllerFF.IDs.ExtensionParameterType.AdHoc, PickListController.Grouping.AdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamShowLockedQuantityForLineAlternatePicking,
				"Alternate: Show locked quantity for current line? (Y/N)",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.True,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_SHOW_LOCKED_STOCK_FOR_LINE_ALTERNATE_PICKING, (int)PickListControllerFF.IDs.ExtensionParameterType.Default, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAutomaticSelectionOfMoveableLocation,
				"Auto selection of moveable location during picking? (Y/N)", PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_AUTOMATIC_SELECTION_OF_MOVEABLE_LOCATION, (int)PickListControllerFF.IDs.ExtensionParameterType.Default, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamStockOrderBy,
				"Stock order by",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_STRING_VALID_VALUE_CONVERTOR,
				PmxPickListStockOrderByCodes.DEFAULT, PmxExtensionParameterCodes.PICKLIST_CONTROLLER_STOCK_ORDER_BY, (int)PickListControllerFF.IDs.ExtensionParameterType.Default, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateParameterValidValue(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_STOCK_ORDER_BY, PmxPickListStockOrderByCodes.DEFAULT, "Default Order by");
			updateProv.AddUpdateParameterValidValue(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_STOCK_ORDER_BY, PmxPickListStockOrderByCodes.LOWEST_QUANTITY_FIRST, "Order by lowest quantity");
			updateProv.AddUpdateParameterValidValue(PmxExtensionParameterCodes.PICKLIST_CONTROLLER_STOCK_ORDER_BY, PmxPickListStockOrderByCodes.BIGGEST_PALLET_FIRST, "Order by Highest quantity, oldest LUID");
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamPickingForceScanSSCCOnItemPicking,
				"Item picking: Force user to scan SSCC when stock is on SSCC? (Y/N)", PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_PICKING_FORCE_SCAN_SSCC_ON_ITEM_PICKING, (int)PickListControllerFF.IDs.ExtensionParameterType.Default, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamAutoFillInQuantityForNoPackingTypes,
				"Auto fill quantity (No packaging types)? (Y/N)",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.True,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_AUTO_FILL_QTY_NO_PACK_TYPES, (int)PickListControllerFF.IDs.ExtensionParameterType.Default, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamMultiPickingSetMovableLocationAtStart,
				"Multi picking: Set movable locations at start of picking? (Y/N)",
				PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.True,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_MULTI_PICK_SET_MOVABLE_LOC_AT_START, (int)PickListControllerFF.IDs.ExtensionParameterType.Default, PickListController.Grouping.MultiPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamSkipIdentifyLocationScreen,
				"Skip screen to identify the pick location? (Y/N)", PickListControllerFF.IDs.ExtCode, Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR,
				ProdumexValues.False, PmxExtensionParameterCodes.PICKLIST_CONTROLLER_SKIP_IDENTIFY_LOCATION_SCREEN, (int)PickListControllerFF.IDs.ExtensionParameterType.Default, PickListController.Grouping.NotAdHocPicking);
			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamMultiPickingAllowToSelectWave,
				"Multi picking: Allow to select wave? (Y/N)", PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				PmxExtensionParameterCodes.PICKLIST_CONTROLLER_MULTI_PICK_ALLOW_TO_SELECT_WAVE, PickListController.Grouping.MultiPicking);


			updateProv.AddUpdateExtensionParameter(PickListControllerFF.IDs.ExtParamOnlyPickOn1SSCC,
				"Only pick on 1 SSCC? (Y/N)",
				PickListControllerFF.IDs.ExtCode,
				Produmex.Foundation.Data.Sbo.BusinessObjects.Definitions.PmxExtensionCodes.SYSTEM_BOOL_CONVERTOR, ProdumexValues.False,
				"PC-OP1S", 1, PickListController.Grouping.NotAdHocPicking);

		}


		/// <summary>
		/// Add/Update <see cref="PmxExtension"/>
		/// </summary>
		/// <param name="code">The code of the extension.</param>
		/// <param name="name">The name of the extension.</param>
		/// <param name="type">The type of the extension.</param>
		/// <param name="extensionTypeCode">The extension type code.</param>
		/// <param name="conn">The SBO connection</param>
		private static void AddUpdateExtension(string code, string name, Type type, string extensionTypeCode, PmxDbConnectionSql conn)
		{
			PmxExtensionProvider prov = new PmxExtensionProvider(conn);
			PmxExtension extension = null;
			try
			{
				bool newBO = false;
				extension = prov.GetBO(code);
				if (extension == null)
				{
					newBO = true;
					extension = prov.GetNewBO();
					extension.Code = code;
				}
				extension.Name = name;
				extension.ExtensionTypeCode = extensionTypeCode;
				extension.Type = ReflectionHelper.GetTypeAndAssemblyName(type);
				if (newBO)
				{
					prov.AddBO(extension);
				}
				else
				{
					prov.UpdateBO(extension, false, false);
				}
			}
			finally
			{
				if (extension != null)
					extension.Dispose();
			}
		}

		/// <summary>
		/// Add/Update script workflow
		/// </summary>
		/// <param name="executionType">Type of the execution.</param>
		/// <param name="name">The name of the flow.</param>
		/// <param name="sourceFilePath">Name of the file.</param>
		/// <param name="sqlConn">The SQL conn.</param>
		private static void AddUpdateWorkflowScript(string executionType, string name, string sourceFilePath, PmxDbConnectionSql sqlConn)
		{
			PmxWorkflowProvider wfProvider = new PmxWorkflowProvider(sqlConn);
			PmxWorkflow workflow = wfProvider.GetWorkflowByName(name);
			PmxWorkflowScriptProvider wfscProvider = new PmxWorkflowScriptProvider(sqlConn);
			PmxWorkflowScript bo = null;
			if (workflow == null)
			{
				//add the workflow
				bo = wfscProvider.GetNewBO();
				bo.Name = name;
				wfscProvider.AddBO(bo);
			}
			else
			{
				if (workflow.ObjType == Produmex.Sbo.Logex.Data.BusinessObjects.Definitions.PmxObjectTypes.PmxWorkflowScript)
				{
					bo = wfscProvider.GetBO(workflow.InternalKey);

				}
			}

			if (bo != null)
			{
				bo.ExecutionType = executionType;

				wfscProvider.UpdateSourceFromFileAndCompile(bo, sourceFilePath, sqlConn);
			}
		}

		/// <summary>
		/// Runs the table SQL script.
		/// </summary>
		/// <param name="tableScript">The table script.</param>
		/// <param name="conn">The conn.</param>
		private static void RunTableSqlScript(string tableScript, PmxDbConnection conn)
		{
			string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.Fairfield.SboCommands)), "Produmex.Sbo.Logex.Fairfield.Scripts.Tables." + tableScript);
			SboRecordsetHelper.RunSqlScript(s_log, content, conn);
		}

		/// <summary>
		/// Adds the update user fields not in transaction.
		/// </summary>
		/// <param name="conn">The conn.</param>
		/// <param name="types">The types.</param>
		private static void AddUpdateUserFieldsNotInTransaction(SboConnection conn, params Type[] types)
		{
			SboUserFieldMDProvider userFieldMDProv = new SboUserFieldMDProvider(conn);
			//System.Data.Common.DbTransaction transaction = null;
			try
			{
				//transaction = this.Connection.BeginTransaction();
				userFieldMDProv.AddUpdateUserFields(types);

				//Commit transaction
				//transaction.Commit();
			}
			catch (Exception)
			{
				//if (transaction != null) transaction.Rollback();
				throw;
			}
		}

		/// <summary>
		/// Runs the stored procedure SQL script.
		/// </summary>
		/// <param name="spScript">The sp script.</param>
		/// <param name="conn">The conn.</param>
		private static void RunStoredProcedureSqlScript(string spScript, PmxDbConnection conn)
		{
			string content = ResourceHelper.ReadResourceContentAsString(Assembly.GetAssembly(typeof(Produmex.Sbo.Logex.Fairfield.SboCommands)), "Produmex.Sbo.Logex.Fairfield.Scripts.StoredProcedures." + spScript);
			SboRecordsetHelper.RunSqlScript(s_log, content, conn);
		}
	}
}
